diff --git a/src/utils/pool_track_table_mutation.c b/src/utils/pool_track_table_mutation.c
new file mode 100644
index 0000000000000000000000000000000000000000..27d4f0380d43a237f518c60cdd73aba2ff51b723
--- /dev/null
+++ b/src/utils/pool_track_table_mutation.c
@@ -0,0 +1,1188 @@
+/* -*-pgsql-c-*- */
+/*
+ * pgpool: a language independent connection pool server for PostgreSQL
+ * written by Tatsuo Ishii
+ *
+ * Copyright (c) 2003-2026	PgPool Global Development Group
+ *
+ * Permission to use, copy, modify, and distribute this software and
+ * its documentation for any purpose and without fee is hereby
+ * granted, provided that the above copyright notice appear in all
+ * copies and that both that copyright notice and this permission
+ * notice appear in supporting documentation, and that the name of the
+ * author not be used in advertising or publicity pertaining to
+ * distribution of the software without specific, written prior
+ * permission. The author makes no representations about the
+ * suitability of this software for any purpose.  It is provided "as
+ * is" without express or implied warranty.
+ *
+ * pool_track_table_mutation.c: In-memory tracking of recently written tables
+ *                    to avoid stale reads from replicas during replication lag
+ *
+ * Based on the "lagless" architecture from Tailor Brands:
+ * https://medium.com/tailor-tech/using-database-read-replicas-in-distributed-systems-d80eaf6bbf8a
+ */
+
+#include <string.h>
+#include <stdlib.h>
+#include <sys/time.h>
+#include <unistd.h>
+
+#include "pool.h"
+#include "pool_config.h"
+#include "context/pool_session_context.h"
+#include "utils/pool_track_table_mutation.h"
+#include "utils/elog.h"
+#include "utils/pool_ipc.h"
+#include "utils/palloc.h"
+#include "utils/pool_relcache.h"
+
+#define DATABASE_TO_OID_QUERY "SELECT oid FROM pg_catalog.pg_database WHERE datname = '%s'"
+
+/* ----------------
+ * Local variables
+ * ----------------
+ */
+
+/* Pointer to shared memory structure */
+static TrackTableMutationShmem *track_table_mutation_shmem = NULL;
+
+/* Per-process cold start tracking (not in shared memory) */
+static struct timeval process_start_time;
+static bool cold_start_initialized = false;
+
+/* ----------------
+ * Helper macros for accessing flexible arrays in shared memory
+ * ----------------
+ */
+
+/* Get pointer to bucket array in table map */
+#define TABLE_MAP_BUCKETS(map) \
+	((int *)((char *)(map) + sizeof(TrackTableMutationHashTable)))
+
+/* Get pointer to entry array in table map */
+#define TABLE_MAP_ENTRIES(map) \
+	((TrackTableMutationEntry *)((char *)(map) + sizeof(TrackTableMutationHashTable) + \
+							(map)->num_buckets * sizeof(int)))
+
+/* Get pointer to bucket array in query cache */
+#define QUERY_CACHE_BUCKETS(cache) \
+	((int *)((char *)(cache) + sizeof(QueryParseCache)))
+
+/* Get pointer to entry array in query cache */
+#define QUERY_CACHE_ENTRIES(cache) \
+	((QueryParseEntry *)((char *)(cache) + sizeof(QueryParseCache) + \
+						 (cache)->num_buckets * sizeof(int)))
+
+/* ----------------
+ * Semaphore lock helpers
+ * ----------------
+ */
+
+static inline void
+table_map_lock(void)
+{
+	pool_semaphore_lock(TRACK_TABLE_MUTATION_TABLE_SEM);
+}
+
+static inline void
+table_map_unlock(void)
+{
+	pool_semaphore_unlock(TRACK_TABLE_MUTATION_TABLE_SEM);
+}
+
+static inline void
+query_cache_lock(void)
+{
+	pool_semaphore_lock(TRACK_TABLE_MUTATION_QUERY_SEM);
+}
+
+static inline void
+query_cache_unlock(void)
+{
+	pool_semaphore_unlock(TRACK_TABLE_MUTATION_QUERY_SEM);
+}
+
+/* ----------------
+ * Hash functions
+ * ----------------
+ */
+
+/*
+ * FNV-1a hash for table/database oid pair
+ */
+static uint32
+fnv1a_hash_table_key(int table_oid, int dboid)
+{
+	uint32 hash = 2166136261u;  /* FNV offset basis */
+	uint32 data[2];
+	const unsigned char *bytes;
+	size_t i;
+
+	data[0] = (uint32) table_oid;
+	data[1] = (uint32) dboid;
+	bytes = (const unsigned char *) data;
+
+	for (i = 0; i < sizeof(data); i++)
+	{
+		hash ^= bytes[i];
+		hash *= 16777619u;  /* FNV prime */
+	}
+
+	return hash;
+}
+
+/*
+ * FNV-1a hash for 64-bit value
+ */
+static uint64
+fnv1a_hash_64(const char *str, size_t len)
+{
+	uint64 hash = 14695981039346656037ULL;  /* FNV offset basis for 64-bit */
+	size_t i;
+
+	for (i = 0; i < len; i++)
+	{
+		hash ^= (uint8)str[i];
+		hash *= 1099511628211ULL;  /* FNV prime for 64-bit */
+	}
+
+	return hash;
+}
+
+/* ----------------
+ * Time utilities
+ * ----------------
+ */
+
+/*
+ * Get elapsed time in microseconds between two timevals
+ */
+static int64
+elapsed_us(struct timeval *start, struct timeval *end)
+{
+	return ((int64)(end->tv_sec - start->tv_sec) * 1000000) +
+		   (end->tv_usec - start->tv_usec);
+}
+
+/*
+ * Get current time
+ */
+static void
+get_current_time(struct timeval *tv)
+{
+	gettimeofday(tv, NULL);
+}
+
+/* ----------------
+ * Database oid lookup
+ * ----------------
+ */
+
+static int
+track_table_mutation_get_database_oid_internal(void)
+{
+	int			oid = 0;
+	static POOL_RELCACHE *relcache;
+	POOL_CONNECTION_POOL *backend;
+	POOL_SESSION_CONTEXT *session_context;
+
+	/* Safety check: must have shmem initialized */
+	if (track_table_mutation_shmem == NULL)
+		return oid;
+
+	session_context = pool_get_session_context(false);
+	if (session_context == NULL)
+		return oid;
+
+	/* Ensure we have a valid query context */
+	if (session_context->query_context == NULL)
+		return oid;
+
+	backend = session_context->backend;
+	if (backend == NULL || MAIN_CONNECTION(backend) == NULL || MAIN_CONNECTION(backend)->sp == NULL)
+		return oid;
+
+	/* Ensure database name is valid */
+	if (MAIN_CONNECTION(backend)->sp->database == NULL)
+		return oid;
+
+	if (!relcache)
+	{
+		relcache = pool_create_relcache(pool_config->relcache_size,
+										DATABASE_TO_OID_QUERY,
+										int_register_func,
+										int_unregister_func,
+										false);
+		if (relcache == NULL)
+		{
+			ereport(LOG,
+					(errmsg("track_table_mutation: error creating relcache while getting database OID")));
+			return oid;
+		}
+	}
+
+	oid = (int) (intptr_t) pool_search_relcache(relcache, backend,
+												MAIN_CONNECTION(backend)->sp->database);
+	return oid;
+}
+
+int
+pool_track_table_mutation_get_database_oid(void)
+{
+	return track_table_mutation_get_database_oid_internal();
+}
+
+/* ----------------
+ * Table mutation hash table operations
+ * ----------------
+ */
+
+/*
+ * Initialize table mutation hash table
+ */
+static void
+table_map_init(TrackTableMutationHashTable *map, int num_buckets, int max_entries)
+{
+	int *buckets;
+	TrackTableMutationEntry *entries;
+	int i;
+
+	map->num_buckets = num_buckets;
+	map->max_entries = max_entries;
+	map->num_entries = 0;
+	map->free_list_head = 0;
+
+	buckets = TABLE_MAP_BUCKETS(map);
+	entries = TABLE_MAP_ENTRIES(map);
+
+	/* Initialize all buckets to empty */
+	for (i = 0; i < num_buckets; i++)
+		buckets[i] = TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	/* Initialize free list - chain all entries */
+	for (i = 0; i < max_entries; i++)
+	{
+		entries[i].in_use = false;
+		entries[i].next = (i < max_entries - 1) ? i + 1 : TRACK_TABLE_MUTATION_INVALID_INDEX;
+	}
+
+	ereport(DEBUG1,
+			(errmsg("track_table_mutation: initialized table map with %d buckets, %d max entries",
+					num_buckets, max_entries)));
+}
+
+/*
+ * Allocate an entry from the free list
+ */
+static int
+table_map_alloc_entry(TrackTableMutationHashTable *map)
+{
+	TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+	int idx;
+
+	if (map->free_list_head == TRACK_TABLE_MUTATION_INVALID_INDEX)
+		return TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	idx = map->free_list_head;
+	map->free_list_head = entries[idx].next;
+	entries[idx].in_use = true;
+	entries[idx].next = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	map->num_entries++;
+
+	return idx;
+}
+
+/*
+ * Free an entry back to the free list
+ */
+static void
+table_map_free_entry(TrackTableMutationHashTable *map, int idx)
+{
+	TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+
+	entries[idx].in_use = false;
+	entries[idx].next = map->free_list_head;
+	map->free_list_head = idx;
+	map->num_entries--;
+}
+
+/*
+ * Look up a table in the hash table
+ * Returns entry index or TRACK_TABLE_MUTATION_INVALID_INDEX if not found
+ * Must be called with lock held
+ */
+static int
+table_map_lookup(TrackTableMutationHashTable *map, int table_oid, int dboid, uint32 hash)
+{
+	int *buckets = TABLE_MAP_BUCKETS(map);
+	TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+	int bucket = hash % map->num_buckets;
+	int idx = buckets[bucket];
+
+	while (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		if (entries[idx].hash == hash &&
+			entries[idx].table_oid == table_oid &&
+			entries[idx].dboid == dboid)
+		{
+			return idx;
+		}
+		idx = entries[idx].next;
+	}
+
+	return TRACK_TABLE_MUTATION_INVALID_INDEX;
+}
+
+/*
+ * Insert or update a table entry
+ * Must be called with lock held
+ */
+static void
+table_map_insert(TrackTableMutationHashTable *map, int table_oid, int dboid,
+				 uint32 hash, struct timeval *write_time)
+{
+	int *buckets = TABLE_MAP_BUCKETS(map);
+	TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+	int bucket = hash % map->num_buckets;
+	int idx;
+
+	/* Check if entry already exists */
+	idx = table_map_lookup(map, table_oid, dboid, hash);
+	if (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		/* Update existing entry */
+		entries[idx].last_write_time = *write_time;
+		return;
+	}
+
+	/* Allocate new entry */
+	idx = table_map_alloc_entry(map);
+	if (idx == TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		int b;
+		/* Table is full - evict an entry */
+		/* For simplicity, just use the first entry in first non-empty bucket */
+		for (b = 0; b < map->num_buckets; b++)
+		{
+			if (buckets[b] != TRACK_TABLE_MUTATION_INVALID_INDEX)
+			{
+				int victim = buckets[b];
+				buckets[b] = entries[victim].next;
+				table_map_free_entry(map, victim);
+				idx = table_map_alloc_entry(map);
+				break;
+			}
+		}
+
+		if (idx == TRACK_TABLE_MUTATION_INVALID_INDEX)
+		{
+			ereport(WARNING,
+					(errmsg("track_table_mutation: failed to allocate entry for table oid %d (dboid %d)",
+							table_oid, dboid)));
+			return;
+		}
+	}
+
+	/* Initialize new entry */
+	entries[idx].table_oid = table_oid;
+	entries[idx].dboid = dboid;
+	entries[idx].hash = hash;
+	entries[idx].last_write_time = *write_time;
+
+	/* Insert at head of bucket chain */
+	entries[idx].next = buckets[bucket];
+	buckets[bucket] = idx;
+
+	ereport(DEBUG2,
+			(errmsg("track_table_mutation: marked table oid %d (dboid %d) as written",
+					table_oid, dboid)));
+}
+
+/*
+ * Remove expired entries from the table map
+ * Must be called with lock held
+ */
+static void
+table_map_cleanup_expired(TrackTableMutationHashTable *map, uint64 ttl_us)
+{
+	int *buckets = TABLE_MAP_BUCKETS(map);
+	TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+	struct timeval now;
+	int removed = 0;
+	int b;
+
+	get_current_time(&now);
+
+	for (b = 0; b < map->num_buckets; b++)
+	{
+		int *prev_ptr = &buckets[b];
+		int idx = buckets[b];
+
+		while (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		{
+			int64 elapsed = elapsed_us(&entries[idx].last_write_time, &now);
+
+			if (elapsed > (int64)ttl_us)
+			{
+				/* Entry has expired - remove it */
+				int next = entries[idx].next;
+				*prev_ptr = next;
+				table_map_free_entry(map, idx);
+				idx = next;
+				removed++;
+			}
+			else
+			{
+				prev_ptr = &entries[idx].next;
+				idx = entries[idx].next;
+			}
+		}
+	}
+
+	if (removed > 0)
+	{
+		ereport(DEBUG1,
+				(errmsg("track_table_mutation: cleaned up %d expired table entries", removed)));
+	}
+}
+
+/* ----------------
+ * Query parse cache operations
+ * ----------------
+ */
+
+/*
+ * Initialize query parse cache
+ */
+static void
+query_cache_init(QueryParseCache *cache, int num_buckets, int max_entries)
+{
+	int *buckets;
+	QueryParseEntry *entries;
+	int i;
+
+	cache->num_buckets = num_buckets;
+	cache->max_entries = max_entries;
+	cache->num_entries = 0;
+	cache->free_list_head = 0;
+	cache->lru_head = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	cache->lru_tail = TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	buckets = QUERY_CACHE_BUCKETS(cache);
+	entries = QUERY_CACHE_ENTRIES(cache);
+
+	/* Initialize all buckets to empty */
+	for (i = 0; i < num_buckets; i++)
+		buckets[i] = TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	/* Initialize free list */
+	for (i = 0; i < max_entries; i++)
+	{
+		entries[i].in_use = false;
+		entries[i].next = (i < max_entries - 1) ? i + 1 : TRACK_TABLE_MUTATION_INVALID_INDEX;
+		entries[i].lru_prev = TRACK_TABLE_MUTATION_INVALID_INDEX;
+		entries[i].lru_next = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	}
+
+	ereport(DEBUG1,
+			(errmsg("track_table_mutation: initialized query cache with %d buckets, %d max entries",
+					num_buckets, max_entries)));
+}
+
+/*
+ * Move entry to front of LRU list (most recently used)
+ */
+static void
+query_cache_lru_touch(QueryParseCache *cache, int idx)
+{
+	QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+
+	/* Already at head? */
+	if (cache->lru_head == idx)
+		return;
+
+	/* Remove from current position */
+	if (entries[idx].lru_prev != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[entries[idx].lru_prev].lru_next = entries[idx].lru_next;
+	if (entries[idx].lru_next != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[entries[idx].lru_next].lru_prev = entries[idx].lru_prev;
+	if (cache->lru_tail == idx)
+		cache->lru_tail = entries[idx].lru_prev;
+
+	/* Insert at head */
+	entries[idx].lru_prev = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	entries[idx].lru_next = cache->lru_head;
+	if (cache->lru_head != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[cache->lru_head].lru_prev = idx;
+	cache->lru_head = idx;
+	if (cache->lru_tail == TRACK_TABLE_MUTATION_INVALID_INDEX)
+		cache->lru_tail = idx;
+}
+
+/*
+ * Add entry to LRU list (at head)
+ */
+static void
+query_cache_lru_add(QueryParseCache *cache, int idx)
+{
+	QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+
+	entries[idx].lru_prev = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	entries[idx].lru_next = cache->lru_head;
+
+	if (cache->lru_head != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[cache->lru_head].lru_prev = idx;
+
+	cache->lru_head = idx;
+
+	if (cache->lru_tail == TRACK_TABLE_MUTATION_INVALID_INDEX)
+		cache->lru_tail = idx;
+}
+
+/*
+ * Remove entry from LRU list
+ */
+static void
+query_cache_lru_remove(QueryParseCache *cache, int idx)
+{
+	QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+
+	if (entries[idx].lru_prev != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[entries[idx].lru_prev].lru_next = entries[idx].lru_next;
+	else
+		cache->lru_head = entries[idx].lru_next;
+
+	if (entries[idx].lru_next != TRACK_TABLE_MUTATION_INVALID_INDEX)
+		entries[entries[idx].lru_next].lru_prev = entries[idx].lru_prev;
+	else
+		cache->lru_tail = entries[idx].lru_prev;
+
+	entries[idx].lru_prev = TRACK_TABLE_MUTATION_INVALID_INDEX;
+	entries[idx].lru_next = TRACK_TABLE_MUTATION_INVALID_INDEX;
+}
+
+/*
+ * Allocate entry from free list, evicting LRU if necessary
+ */
+static int
+query_cache_alloc_entry(QueryParseCache *cache)
+{
+	QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+	int *buckets = QUERY_CACHE_BUCKETS(cache);
+	int idx;
+
+	if (cache->free_list_head != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		idx = cache->free_list_head;
+		cache->free_list_head = entries[idx].next;
+		entries[idx].in_use = true;
+		entries[idx].next = TRACK_TABLE_MUTATION_INVALID_INDEX;
+		cache->num_entries++;
+		return idx;
+	}
+
+	/* No free entries - evict LRU */
+	if (cache->lru_tail == TRACK_TABLE_MUTATION_INVALID_INDEX)
+		return TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	idx = cache->lru_tail;
+
+	/* Remove from hash bucket */
+	int bucket = entries[idx].query_hash % cache->num_buckets;
+	int *prev_ptr = &buckets[bucket];
+	int curr = buckets[bucket];
+
+	while (curr != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		if (curr == idx)
+		{
+			*prev_ptr = entries[curr].next;
+			break;
+		}
+		prev_ptr = &entries[curr].next;
+		curr = entries[curr].next;
+	}
+
+	/* Remove from LRU list */
+	query_cache_lru_remove(cache, idx);
+
+	/* Reinitialize entry */
+	entries[idx].in_use = true;
+	entries[idx].next = TRACK_TABLE_MUTATION_INVALID_INDEX;
+
+	return idx;
+}
+
+/*
+ * Look up a query in the cache
+ */
+static int
+query_cache_lookup(QueryParseCache *cache, uint64 hash)
+{
+	int *buckets = QUERY_CACHE_BUCKETS(cache);
+	QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+	int bucket = hash % cache->num_buckets;
+	int idx = buckets[bucket];
+
+	while (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		if (entries[idx].query_hash == hash)
+			return idx;
+		idx = entries[idx].next;
+	}
+
+	return TRACK_TABLE_MUTATION_INVALID_INDEX;
+}
+
+/* ----------------
+ * Query normalization
+ * ----------------
+ */
+
+/*
+ * Simple query normalization:
+ * - Strip comments (-- style and C-style block comments)
+ * - Collapse whitespace
+ * - Convert to lowercase (except inside strings)
+ * - Replace literal values with placeholders
+ *
+ * This is a simplified version - pgpool2 already does this elsewhere,
+ * but we need a standalone version for the track table mutation feature.
+ */
+static size_t
+normalize_query(const char *query, char *output, size_t output_size)
+{
+	const char *src = query;
+	char *dst = output;
+	char *dst_end = output + output_size - 1;
+	bool in_string = false;
+	char string_char = 0;
+	bool last_was_space = true;  /* Start true to skip leading space */
+
+	while (*src && dst < dst_end)
+	{
+		/* Handle string literals */
+		if (in_string)
+		{
+			if (*src == string_char)
+			{
+				if (*(src + 1) == string_char)
+				{
+					/* Escaped quote */
+					src += 2;
+					continue;
+				}
+				in_string = false;
+				*dst++ = '$';  /* Replace string content with placeholder */
+			}
+			src++;
+			continue;
+		}
+
+		/* Check for string start */
+		if (*src == '\'' || *src == '"')
+		{
+			in_string = true;
+			string_char = *src;
+			src++;
+			continue;
+		}
+
+		/* Handle single-line comments */
+		if (*src == '-' && *(src + 1) == '-')
+		{
+			while (*src && *src != '\n')
+				src++;
+			continue;
+		}
+
+		/* Handle multi-line comments */
+		if (*src == '/' && *(src + 1) == '*')
+		{
+			src += 2;
+			while (*src && !(*src == '*' && *(src + 1) == '/'))
+				src++;
+			if (*src)
+				src += 2;
+			continue;
+		}
+
+		/* Handle whitespace */
+		if (*src == ' ' || *src == '\t' || *src == '\n' || *src == '\r')
+		{
+			if (!last_was_space)
+			{
+				*dst++ = ' ';
+				last_was_space = true;
+			}
+			src++;
+			continue;
+		}
+
+		/* Handle numbers - replace with placeholder */
+		if ((*src >= '0' && *src <= '9') ||
+			(*src == '.' && *(src + 1) >= '0' && *(src + 1) <= '9'))
+		{
+			while (*src && ((*src >= '0' && *src <= '9') || *src == '.'))
+				src++;
+			if (!last_was_space && dst > output && *(dst - 1) != '$')
+				*dst++ = '$';
+			last_was_space = false;
+			continue;
+		}
+
+		/* Regular character - convert to lowercase */
+		if (*src >= 'A' && *src <= 'Z')
+			*dst++ = *src + 32;
+		else
+			*dst++ = *src;
+
+		last_was_space = false;
+		src++;
+	}
+
+	/* Remove trailing space */
+	if (dst > output && *(dst - 1) == ' ')
+		dst--;
+
+	*dst = '\0';
+	return dst - output;
+}
+
+/* ----------------
+ * Public API implementation
+ * ----------------
+ */
+
+Size
+pool_track_table_mutation_shmem_size(void)
+{
+	Size size = 0;
+	int table_buckets = pool_config->track_table_mutation_table_buckets;
+	int table_size = pool_config->track_table_mutation_table_size;
+	int query_buckets = pool_config->track_table_mutation_query_buckets;
+	int query_cache_size = pool_config->track_table_mutation_query_parse_cache_size;
+
+	/* Main structure */
+	size += sizeof(TrackTableMutationShmem);
+
+	/* Table mutation hash table */
+	size += sizeof(TrackTableMutationHashTable);
+	size += table_buckets * sizeof(int);  /* buckets array */
+	size += table_size * sizeof(TrackTableMutationEntry);  /* entries array */
+
+	/* Query parse cache */
+	size += sizeof(QueryParseCache);
+	size += query_buckets * sizeof(int);  /* buckets array */
+	size += query_cache_size * sizeof(QueryParseEntry);  /* entries array */
+
+	return size;
+}
+
+void
+pool_track_table_mutation_init(void)
+{
+#ifndef POOL_PRIVATE
+	Size shmem_size;
+	char *shmem_ptr;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL)
+	{
+		ereport(DEBUG1,
+				(errmsg("track_table_mutation: feature disabled")));
+		return;
+	}
+
+	shmem_size = pool_track_table_mutation_shmem_size();
+
+	/*
+	 * Allocate from the main shared memory segment.
+	 * Memory is already zeroed by initialize_shared_memory_main_segment().
+	 */
+	shmem_ptr = pool_shared_memory_segment_get_chunk(shmem_size);
+	if (shmem_ptr == NULL)
+	{
+		ereport(ERROR,
+				(errmsg("track_table_mutation: failed to allocate %zu bytes of shared memory",
+						shmem_size)));
+		return;
+	}
+
+	/* Set up pointers to structures within shared memory */
+	track_table_mutation_shmem = (TrackTableMutationShmem *)shmem_ptr;
+	shmem_ptr += sizeof(TrackTableMutationShmem);
+
+	track_table_mutation_shmem->table_map = (TrackTableMutationHashTable *)shmem_ptr;
+	shmem_ptr += sizeof(TrackTableMutationHashTable);
+	shmem_ptr += pool_config->track_table_mutation_table_buckets * sizeof(int);
+	shmem_ptr += pool_config->track_table_mutation_table_size * sizeof(TrackTableMutationEntry);
+
+	track_table_mutation_shmem->query_cache = (QueryParseCache *)shmem_ptr;
+
+	/* Initialize structures */
+	table_map_init(track_table_mutation_shmem->table_map,
+				   pool_config->track_table_mutation_table_buckets,
+				   pool_config->track_table_mutation_table_size);
+
+	query_cache_init(track_table_mutation_shmem->query_cache,
+					 pool_config->track_table_mutation_query_buckets,
+					 pool_config->track_table_mutation_query_parse_cache_size);
+
+	/* Initialize global state */
+	track_table_mutation_shmem->state.initialized = true;
+	track_table_mutation_shmem->state.current_ttl_us = TRACK_TABLE_MUTATION_DEFAULT_TTL_US;
+	get_current_time(&track_table_mutation_shmem->state.ttl_last_updated);
+	get_current_time(&track_table_mutation_shmem->state.last_cleanup_time);
+	track_table_mutation_shmem->state.global_cold_start_until.tv_sec = 0;
+	track_table_mutation_shmem->state.global_cold_start_until.tv_usec = 0;
+	track_table_mutation_shmem->state.stats_queries_checked = 0;
+	track_table_mutation_shmem->state.stats_forced_primary = 0;
+	track_table_mutation_shmem->state.stats_allowed_replica = 0;
+
+	ereport(LOG,
+			(errmsg("track_table_mutation: initialized with %zu bytes shared memory",
+					shmem_size)));
+#endif
+}
+
+void
+pool_track_table_mutation_child_init(void)
+{
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return;
+
+	get_current_time(&process_start_time);
+	cold_start_initialized = true;
+
+	ereport(DEBUG1,
+			(errmsg("track_table_mutation: child initialized, cold start period %d ms",
+					pool_config->track_table_mutation_cold_start_duration)));
+}
+
+bool
+pool_track_table_mutation_in_cold_start(void)
+{
+	struct timeval now;
+	int64 elapsed_ms;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return false;
+
+	if (pool_config->track_table_mutation_cold_start_duration <= 0)
+		return false;
+
+	get_current_time(&now);
+
+	/* Check for watchdog-triggered global cold start first */
+	if (track_table_mutation_shmem->state.global_cold_start_until.tv_sec != 0 &&
+		elapsed_us(&now, &track_table_mutation_shmem->state.global_cold_start_until) > 0)
+	{
+		return true;
+	}
+
+	/* Check per-process cold start */
+	if (!cold_start_initialized)
+		return false;
+
+	elapsed_ms = elapsed_us(&process_start_time, &now) / 1000;
+
+	if (elapsed_ms < pool_config->track_table_mutation_cold_start_duration)
+	{
+		ereport(DEBUG2,
+				(errmsg("track_table_mutation: in cold start (%ld/%d ms)",
+						(long)elapsed_ms, pool_config->track_table_mutation_cold_start_duration)));
+		return true;
+	}
+
+	return false;
+}
+
+void
+pool_track_table_mutation_trigger_global_cold_start(void)
+{
+	struct timeval now;
+	int duration_ms;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return;
+
+	duration_ms = pool_config->track_table_mutation_cold_start_duration;
+	if (duration_ms <= 0)
+		return;
+
+	get_current_time(&now);
+	track_table_mutation_shmem->state.global_cold_start_until = now;
+	track_table_mutation_shmem->state.global_cold_start_until.tv_sec += duration_ms / 1000;
+	track_table_mutation_shmem->state.global_cold_start_until.tv_usec += (duration_ms % 1000) * 1000;
+	if (track_table_mutation_shmem->state.global_cold_start_until.tv_usec >= 1000000)
+	{
+		track_table_mutation_shmem->state.global_cold_start_until.tv_sec +=
+			track_table_mutation_shmem->state.global_cold_start_until.tv_usec / 1000000;
+		track_table_mutation_shmem->state.global_cold_start_until.tv_usec %=
+			1000000;
+	}
+
+	ereport(LOG,
+			(errmsg("track_table_mutation: entering global cold start for %d ms",
+					duration_ms)));
+}
+
+bool
+pool_track_table_mutation_table_is_stale(int table_oid, int dboid)
+{
+	TrackTableMutationHashTable *map;
+	struct timeval now;
+	uint64 ttl_us;
+	uint32 hash;
+	int idx;
+	bool is_stale = false;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return false;
+
+	if (table_oid <= 0 || dboid <= 0)
+	{
+		is_stale = true;
+		goto update_stats;
+	}
+
+	map = track_table_mutation_shmem->table_map;
+	hash = fnv1a_hash_table_key(table_oid, dboid);
+
+	table_map_lock();
+
+	idx = table_map_lookup(map, table_oid, dboid, hash);
+	if (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		TrackTableMutationEntry *entries = TABLE_MAP_ENTRIES(map);
+		get_current_time(&now);
+		ttl_us = track_table_mutation_shmem->state.current_ttl_us;
+
+		int64 elapsed = elapsed_us(&entries[idx].last_write_time, &now);
+		is_stale = (elapsed < (int64)ttl_us);
+
+		ereport(DEBUG2,
+				(errmsg("track_table_mutation: table oid %d (dboid %d) elapsed=%ld us, ttl=%lu us, stale=%d",
+						table_oid, dboid, (long)elapsed, (unsigned long)ttl_us, is_stale)));
+	}
+
+	table_map_unlock();
+
+update_stats:
+	/* Update statistics - skip if shmem not available */
+	if (track_table_mutation_shmem != NULL)
+	{
+		__sync_fetch_and_add(&track_table_mutation_shmem->state.stats_queries_checked, 1);
+		if (is_stale)
+			__sync_fetch_and_add(&track_table_mutation_shmem->state.stats_forced_primary, 1);
+		else
+			__sync_fetch_and_add(&track_table_mutation_shmem->state.stats_allowed_replica, 1);
+	}
+
+	return is_stale;
+}
+
+void
+pool_track_table_mutation_mark_tables_written(const int *table_oids, int num_tables, int dboid)
+{
+	TrackTableMutationHashTable *map;
+	struct timeval now;
+	int i;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return;
+
+	if (num_tables <= 0 || table_oids == NULL || dboid <= 0)
+		return;
+
+	map = track_table_mutation_shmem->table_map;
+	get_current_time(&now);
+
+	table_map_lock();
+
+	/* Periodically clean up expired entries */
+	if (map->num_entries > map->max_entries * 3 / 4)
+	{
+		/* Limit cleanup frequency to avoid O(N) scan on every write */
+		/* 100ms interval */
+		if (elapsed_us(&track_table_mutation_shmem->state.last_cleanup_time, &now) > 100000)
+		{
+			table_map_cleanup_expired(map, track_table_mutation_shmem->state.current_ttl_us);
+			track_table_mutation_shmem->state.last_cleanup_time = now;
+		}
+	}
+
+	for (i = 0; i < num_tables; i++)
+	{
+		uint32 hash;
+		int table_oid = table_oids[i];
+
+		if (table_oid > 0)
+		{
+			hash = fnv1a_hash_table_key(table_oid, dboid);
+			table_map_insert(map, table_oid, dboid, hash, &now);
+		}
+	}
+
+	table_map_unlock();
+}
+
+/*
+ * Convenience function to mark a single table as written
+ */
+void
+pool_track_table_mutation_mark_table_written(int table_oid, int dboid)
+{
+	if (table_oid > 0 && dboid > 0)
+	{
+		const int tables[1] = { table_oid };
+		pool_track_table_mutation_mark_tables_written(tables, 1, dboid);
+	}
+}
+
+void
+pool_track_table_mutation_update_ttl(uint64 delay_us)
+{
+	uint64 new_ttl;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return;
+
+	/* Calculate new TTL: delay * factor, with minimum of default TTL */
+	new_ttl = (uint64)(delay_us * pool_config->track_table_mutation_ttl_factor);
+	if (new_ttl < TRACK_TABLE_MUTATION_DEFAULT_TTL_US)
+		new_ttl = TRACK_TABLE_MUTATION_DEFAULT_TTL_US;
+
+	/* Maximum TTL of 1 hour */
+	if (new_ttl > 3600ULL * 1000000ULL)
+		new_ttl = 3600ULL * 1000000ULL;
+
+	track_table_mutation_shmem->state.current_ttl_us = new_ttl;
+	get_current_time(&track_table_mutation_shmem->state.ttl_last_updated);
+
+	ereport(DEBUG1,
+			(errmsg("track_table_mutation: updated TTL to %lu us (delay=%lu us, factor=%.1f)",
+					(unsigned long)new_ttl, (unsigned long)delay_us,
+					pool_config->track_table_mutation_ttl_factor)));
+}
+
+bool
+pool_track_table_mutation_get_cached_parse(uint64 hash, bool *is_write,
+								 char table_names[][TRACK_TABLE_MUTATION_TABLE_NAME_LEN],
+								 int *num_tables)
+{
+	QueryParseCache *cache;
+	int idx;
+	bool found = false;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return false;
+
+	cache = track_table_mutation_shmem->query_cache;
+
+	query_cache_lock();
+
+	idx = query_cache_lookup(cache, hash);
+	if (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		QueryParseEntry *entries = QUERY_CACHE_ENTRIES(cache);
+		int i;
+
+		*is_write = entries[idx].is_write;
+		*num_tables = entries[idx].num_tables;
+
+		for (i = 0; i < entries[idx].num_tables && i < TRACK_TABLE_MUTATION_MAX_TABLES_PER_QUERY; i++)
+		{
+			strlcpy(table_names[i], entries[idx].table_names[i], TRACK_TABLE_MUTATION_TABLE_NAME_LEN);
+		}
+
+		/* Move to front of LRU */
+		query_cache_lru_touch(cache, idx);
+		found = true;
+	}
+
+	query_cache_unlock();
+
+	return found;
+}
+
+void
+pool_track_table_mutation_cache_parse(uint64 hash, bool is_write,
+							const char table_names[][TRACK_TABLE_MUTATION_TABLE_NAME_LEN],
+							int num_tables)
+{
+	QueryParseCache *cache;
+	int *buckets;
+	QueryParseEntry *entries;
+	int idx;
+	int bucket;
+
+	if (pool_config->disable_load_balance_on_write != DLBOW_DML_ADAPTIVE_GLOBAL || track_table_mutation_shmem == NULL)
+		return;
+
+	cache = track_table_mutation_shmem->query_cache;
+
+	query_cache_lock();
+
+	/* Check if already exists */
+	idx = query_cache_lookup(cache, hash);
+	if (idx != TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		query_cache_unlock();
+		return;
+	}
+
+	/* Allocate new entry (may evict LRU) */
+	idx = query_cache_alloc_entry(cache);
+	if (idx == TRACK_TABLE_MUTATION_INVALID_INDEX)
+	{
+		query_cache_unlock();
+		ereport(WARNING,
+				(errmsg("track_table_mutation: failed to allocate query cache entry")));
+		return;
+	}
+
+	entries = QUERY_CACHE_ENTRIES(cache);
+	buckets = QUERY_CACHE_BUCKETS(cache);
+
+	/* Fill in entry */
+	entries[idx].query_hash = hash;
+	entries[idx].is_write = is_write;
+	entries[idx].num_tables = (num_tables > TRACK_TABLE_MUTATION_MAX_TABLES_PER_QUERY) ?
+							  TRACK_TABLE_MUTATION_MAX_TABLES_PER_QUERY : num_tables;
+
+	{
+		int i;
+		for (i = 0; i < entries[idx].num_tables; i++)
+		{
+			strlcpy(entries[idx].table_names[i], table_names[i], TRACK_TABLE_MUTATION_TABLE_NAME_LEN);
+		}
+	}
+
+	/* Insert into hash bucket */
+	bucket = hash % cache->num_buckets;
+	entries[idx].next = buckets[bucket];
+	buckets[bucket] = idx;
+
+	/* Add to LRU list */
+	query_cache_lru_add(cache, idx);
+
+	query_cache_unlock();
+}
+
+uint64
+pool_track_table_mutation_normalize_and_hash(const char *query)
+{
+	char normalized[8192];
+	size_t len;
+
+	if (query == NULL || query[0] == '\0')
+		return 0;
+
+	len = normalize_query(query, normalized, sizeof(normalized));
+	if (len == 0)
+		return 0;
+
+	return fnv1a_hash_64(normalized, len);
+}
-- 
2.53.0

